import 'package:flutter/material.dart';

class AdsFlutterBannerSize {
  final int width, height;
  final String? name;

  static const AdsFlutterBannerSize BANNER =
      AdsFlutterBannerSize(width: 320, height: 50, name: 'BANNER');
  static const AdsFlutterBannerSize LARGE_BANNER =
      AdsFlutterBannerSize(width: 320, height: 100, name: 'LARGE_BANNER');
  static const AdsFlutterBannerSize MEDIUM_RECTANGLE =
      AdsFlutterBannerSize(width: 300, height: 250, name: 'MEDIUM_RECTANGLE');
  static const AdsFlutterBannerSize FULL_BANNER =
      AdsFlutterBannerSize(width: 468, height: 60, name: 'FULL_BANNER');
  static const AdsFlutterBannerSize LEADERBOARD =
      AdsFlutterBannerSize(width: 728, height: 90, name: 'LEADERBOARD');
  AdsFlutterBannerSize.SMART_BANNER(BuildContext context):
        width = MediaQuery.of(context).size.width.toInt(), height = -2, name = 'SMART_BANNER';
  AdsFlutterBannerSize.ADAPTIVE_BANNER({required int width}):
      width = width, height = -2, name = 'ADAPTIVE_BANNER'; 

  const AdsFlutterBannerSize({
    required this.width,
    required this.height,
    this.name,
  });

  bool get hasFixedSize => width > 0 && height > 0;

  Map<String, dynamic> get toMap => <String, dynamic>{
        'width': width,
        'height': height,
        'name': name,
      };
}
